import java.net.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.text.*;



public class DB {
 
  Msql msql;

  // needed for pricing
  int price=0;
  int signal=0;

  // Constructor
  DB() {
    msql = new Msql();
  }

  public static void main () {
   // nothing inside
  }

  int connect_db(Msql msql) {
    try {
     // connecting on maraca on port 4333
          msql.Connect("maraca",false);
          msql.SelectDB("ais");
    } catch (MsqlException e) {
     // on error return -1
     return(-1);
    }
   return(0);
  }

  int disconnect_db(Msql msql) {
    try {
     // disconnecting from maraca on port 4333
          msql.Close();
    } catch (MsqlException e) {
     // on error return -1
     return(-1);
    }
   return(0);
  }

  
  // AIS Project  
  
  public int authenticate(String username, String password)
  {
    String row[];
    String command;
    System.err.println(username);
    connect_db(msql);
    command="select username,password from pswd " +
             "where username='" + username + "'";
    try {
      MsqlResult result = msql.Query(command);
     if (result.NumRows() != 0) {
      row = result.FetchRow();
      System.err.println(row[0]);
      if (row[1].equals(password)) {
        disconnect_db(msql);
        return(1);
      }
     }
    } catch (MsqlException e) { }
    disconnect_db(msql);
    return(-1);
  }
  
  
  public String[][] list_clients() {
   String command;
   connect_db(msql);
   command = "select * from clients";
   try {
     int counter=0;
     MsqlResult result = msql.Query(command);
     String row[];
     String clients[][] = new String[result.NumRows()][3];
     while((row = result.FetchRow()) != null) {
        clients[counter][0]=row[0];
        clients[counter][1]=row[1];
        clients[counter++][2]=row[2];        
        System.err.println(row[0]+" "+row[1]+" "+row[2]);
     }                              
     disconnect_db(msql);
     return(clients);
   } catch (MsqlException e) { 
       String clients[][] = new String[0][3];
       disconnect_db(msql);
       return(clients);
     }
  }
 
 
 public int Enter(String name,String sdate,String stime,
                   String edate, String etime, String command)
 {
    connect_db(msql);
    String exec;

    exec = "insert into storage values ('" +
       name + "','" + sdate + "','" +
       stime + "','" + edate + "','" +
       etime + "','" +
       command + "','This is a sample output file for the" + 
       " execution of a simulation in "+name+"')";
     System.err.println(exec);       
      try {
       msql.Query(exec);
      } catch (MsqlException e) { return(-1); }
    disconnect_db(msql);
    return(1);

 }
 
 
 
 
 
 
 
 
 
 
  public void partially_update_log (Hashtable connections) {
   
    String entry;
    String value;
    
    connect_db(msql);
    
    for (Enumeration e= connections.elements(); e.hasMoreElements();){
      entry = (String) e.nextElement();
      value = construct_query(entry);
      System.err.println("Sending " + entry + "to parser");
      System.err.println("DB GOT "+ value);
            try {
              msql.Query(
               "insert into logs " + 
               "(username,class,bw,dest,sdate,stime,edate," +
               "etime,hops,price) " +
               "values " + value
       
              );
           } catch (MsqlException e2) {}
    }

    disconnect_db(msql);
    
  }

 
  String construct_query(String value) {
    int start=0;
    int end=0;
    // Setting up with ('
    String parsed="('";
    // Keeping the username
    end = value.indexOf("_"); 
    // Having ('psebos',
    parsed = parsed + value.substring(start,end) + "',";   
    // Ready to get next number
    start = value.indexOf(" ")+1; 
    end = value.indexOf(" ",start); 
    // have ('psebos',2,
    parsed = parsed + value.substring(start,end) + ",";
    // Ready to get next number
    start = value.indexOf(" ",end)+1; 
    end = value.indexOf(" ",start); 
    // have ('psebos',2,3,
    parsed = parsed + value.substring(start,end) + ",";
    // Ready to get Destination
    start = value.indexOf(" ",end)+1;
    end = value.indexOf(" ",start);
    // have ('psebos',2,3,5,'
    parsed = parsed + value.substring(start,end) + ",'";
    // Ready to get starting date
    start = value.indexOf(" ",end)+1; 
    end = value.indexOf(" ",start); 
    // have ('psebos',2,3,'2-Jan-1998','
    parsed = parsed + value.substring(start,end) + "','";
    // Ready to get starting time
    start = value.indexOf(" ",end)+1; 
    end = value.indexOf(" ",start); 
    // have ('psebos',2,3,'2-Jan-1998','23:00:10','
    parsed = parsed + value.substring(start,end) + "','";
    // Ready to get ending date
    start = value.indexOf(" ",end)+1; 
    end = value.indexOf(" ",start); 
    // have ('psebos',2,3,'2-Jan-1998','23:00:10','3-Feb-1998','
    parsed = parsed + value.substring(start,end) + "','";
    // Ready to get ending time
    start = value.indexOf(" ",end)+1; 
    end = value.indexOf(" ",start); 
    // have ('psebos',2,3,'2-Jan-1998','23:00:10','3-Feb-1998','12:12:12',
    parsed = parsed + value.substring(start,end) + "',";
    // Ready to get hops
    start = value.indexOf(" ",end)+1; 
    end = value.indexOf(" ",start); 
    // have ('psebos',2,3,'2-Jan-1998','23:00:10','3-Feb-1998','12:12:12',2)
    parsed = parsed + value.substring(start) + ",0)";
    return(parsed);

  }



  // Retreiving the users list
  public String[] list_users() {
   String command;
   connect_db(msql);
   command = "select username from pswd";
   try {
     int counter=0;
     MsqlResult result = msql.Query(command);
     String row[];
     String users[] = new String[result.NumRows()];
     while((row = result.FetchRow()) != null) 
                                  users[counter++]=row[0];
     disconnect_db(msql);
     return(users);
   } catch (MsqlException e) { 
       String users[] = new String[0];
       disconnect_db(msql);
       return(users);
     }
  }



  // Printing the bad users
  public String[] bill(int flag) {
    String command;
    connect_db(msql);
    if (flag == 1) bill_users();
    command = "select username from billing where "+
              "balance >= threshold";
    try {
     int counter=0;
     MsqlResult result = msql.Query(command);
     String row[];
     String badusers[] = new String[result.NumRows()];
     while((row = result.FetchRow()) != null) 
                                  badusers[counter++]=row[0];
     disconnect_db(msql);
     return(badusers);
    } catch (MsqlException e) { 
       String badusers[] = new String[0];
       disconnect_db(msql);
       return(badusers);
      }
  }






  public void bill_users() {
    
    String username="";
    String class_id;
    String bw;
    String dest;
    String hops;
    String sdate;
    String stime;
    String edate;
    String etime;
    String old_username=""; 
    int flag=0;
    // duration in seconds
    long duration;
    int updated_price;
    int overall_balance=0;
    connect_db(msql);
    try {
      // Getting log values from the table
      MsqlResult result = msql.Query(
           "select * from logs where price=0 " +
           "order by class,sdate,stime"
      );
     
      // Grabbing each one
      String row[];
      int counter=0;
      while((row = result.FetchRow()) != null) {
        username = row[0];
        if (flag == 0) { old_username=username; flag=1;}
        class_id = row[1];
        bw = row[2];
        dest = row[3];
        hops = row[4];
        sdate = row[5];
        stime = row[6];
        edate = row[7];
        etime = row[8];
        // Start updating balance
        if (!username.equals(old_username)) {
          String com = "select balance from billing where username='"+old_username+"'";
          System.err.println(com);
          MsqlResult result1 = msql.Query(
               "select balance from billing where username='"+old_username+"'");
          
          String row1[] = result1.FetchRow();
          overall_balance=overall_balance+Integer.parseInt(row1[0]);
          update_balance(old_username,overall_balance,-1);
          System.err.println("Update "+overall_balance+" "+old_username);
          old_username = username;
          overall_balance=0;
        }
        get_price(class_id,stime,etime);
        duration = find_duration(sdate,stime,edate,etime);
        updated_price = (int) duration * price + signal;
        overall_balance=overall_balance + updated_price;
        System.err.println("User "+username+" price "+updated_price+
                           " duration "+duration +" pricepm "+price);
        System.err.println(" ");
        connect_db(msql);
        // now we have to update our database
           msql.Query(
               "update logs set price=" + updated_price +
               " where username='" + username +
               "' AND sdate='" + sdate +
               "' AND stime='" + stime +
               "' AND edate='" + edate +
               "' AND etime='" + etime +
               "' AND bw=" + bw +
               " AND hops=" + hops +
               " AND class=" + class_id
          );
       

      }

    } catch (MsqlException e) {}
          // Update for the last user
          update_balance(username,overall_balance,-1);
          System.err.println("Update "+overall_balance+" "+username);

    //disconnect_db(msql);

  }


  
  long find_duration(String sdate,String stime,String edate,String etime) {
    SimpleDateFormat pdt = new SimpleDateFormat ("dd-MMM-yy HH:mm:ss");
    Date start,end;
    ParsePosition p = new ParsePosition(0);
    ParsePosition q = new ParsePosition(0);
    start = pdt.parse(sdate + " " + stime, p);
    end = pdt.parse(edate + " " + etime, q);
    return((end.getTime()-start.getTime())/1000);
  }


  // getting current price of a user
  void get_price(String class_id, String stime, String etime) {
    connect_db(msql);
    try { 
     MsqlResult result = msql.Query(
       "select price,signal from policy " +
       "where stime<='" + stime + "' AND " +
       "etime>='" + etime + "'" +
       " AND class=" +
       class_id
     );

     String row[];
     if ((row = result.FetchRow()) != null) {
       price = Integer.parseInt(row[0]);
       signal = Integer.parseInt(row[1]);
     }
     else {
        // If there is a problem use default values
        price = 100;
        signal = 2;
     }
    } catch (MsqlException e) { }
    System.err.println("Here " + stime + " " + etime + " " + class_id + " " + price);

  }


  // Show in the Client application the classes
  public int[] get_traffic_classes() {
    int classes[];
    connect_db(msql);
    SimpleDateFormat pdt = new SimpleDateFormat ("HH:mm:ss");
    Date now = new Date();
    String d = pdt.format(now);
    SimpleDateFormat pd = new SimpleDateFormat ("HHmmss");
    ParsePosition p = new ParsePosition(0);
    int start,end;
    
    connect_db(msql);
    classes = new int[1];
    try {
     MsqlResult result = msql.Query(
       "select class,price,signal from policy " +
       "where stime<='" + d + "' AND " +
       "etime>='" + d + "' order by class"
     );
     String row[];
     classes = new int[2*result.NumRows()];
     int counter=0;
     while ((row = result.FetchRow()) != null) {
       classes[counter]= Integer.parseInt(row[1]);
       counter++;
       classes[counter]= Integer.parseInt(row[2]);
       counter++;
     }
    } catch (MsqlException e) { }
    disconnect_db(msql);
    return(classes);

  } 


  // Show in the client application his balance
  public int[] show_balance(String username) {
   int value[];
   connect_db(msql);
   value = new int[2];
    try {
     MsqlResult result = msql.Query(
       "select balance,threshold from billing " +
       "where username='" + username + "'"
     );
     String row[];
     row = result.FetchRow();
     value[0]= Integer.parseInt(row[0]);
     value[1]= Integer.parseInt(row[1]);
    } catch (MsqlException e) { }
   disconnect_db(msql);
   return(value);
  }

  // Update balance in the matrix
  public int update_threshold(String username, int threshold) {
   connect_db(msql);
   String command;
   command = "update billing set threshold=" + threshold
   + " where username='" + username + "'";
   
   System.err.println ( command );     
   try {
     msql.Query(command);
   } catch (MsqlException e) {
      return(-1);
     }
   return(0);
  }


  // Update balance in the matrix
  public int update_balance(String username, int balance, int threshold) {
   connect_db(msql);
   String command;
   command = "update billing set balance=" + balance;
   if (threshold >= 0) {
    command = command + ",threshold=" + threshold;
   }
   command = command + " where username='" + username + "'";
   
   System.err.println ( command );     
   try {
     msql.Query(command);
   } catch (MsqlException e) {
      return(-1);
     }
   return(0);
  }

  //public int update_balance(String username, int balance) {
  //  this(username, balance, -1);
  //}



  // Get information about the user
  // Output is a String
  // [0] fullname
  // [1] email
  // [2] credit card
  // [3] password
  public String[] get_info(String username) {
    String info[]  = new String[4];
    String row[];
    String command1;
    String command2;
    connect_db(msql);
    command1="select password from pswd " +
             "where username='" + username + "'";
    try {
     MsqlResult result = msql.Query(command1);
     row = result.FetchRow(); 
     info[3] = row[0];
    } catch (MsqlException e) { }

    command2="select name,email,card from billing " +
             "where username='" + username + "'";
    try {
     MsqlResult result = msql.Query(command2);
     row = result.FetchRow(); 
     info[0]= row[0];
     info[1]= row[1];
     info[2]= row[2];
    } catch (MsqlException e) { }
    disconnect_db(msql);
    return(info);
  }

  // Create account
  // Gets as an input an array of strings
  // [0] username
  // [1] password
  // [2] threshold
  // [3] name
  // [4] email
  // [5] card
  // pswd : username,password,profile(int)
  // billing : username,balance,threshold,name,e-mail,card,profile(char(2))
  // It returns back 
  // 0 ok
  // 1 account username found
  // -1 generic error
  public int create_account(String[] info) {
   String check, billing, pswd;
   connect_db(msql);
   check = "select username from pswd where username='" + info[0] +"'";
   System.err.println(check);
   System.err.println("");
   try {
     String row[] = new String[1];
     MsqlResult result = msql.Query(check);
     row = result.FetchRow();
     if (row[0].equals("")) return(1);
   }  catch (MsqlException e) {
      }
      catch (NullPointerException e2) {
       pswd = "insert into pswd values('" + info[0] +
       "','" + info[1] + "',0)";   
       billing = "insert into billing values('" + info[0] +
       "',0," + info[2] + ",'" + info[3] + "','" + info[4] +
       "','" + info[5] + "','A')";
       System.err.println(pswd);
       System.err.println("");
       System.err.println(billing);
       System.err.println("");
       try {
         msql.Query(pswd);
         msql.Query(billing);
       } catch (MsqlException e3) {
           disconnect_db(msql);
           return(-1);
         }

       disconnect_db(msql);
       return(0);

      }
   disconnect_db(msql);
   return(1);
  }
  
  
  // Delete Account
  // >0 remaining balance
  // -1 error
  // -2 account username found
  public int delete_account(String username) {
   String check, pswd, billing;
   int back = 0;
   check = "select balance from billing where username='" + username +"'";
   System.err.println(check);
   System.err.println("");
   try {
     String row[] = new String[1];
     MsqlResult result = msql.Query(check);
     if (result.NumRows()==0) {
        disconnect_db(msql);
        return(-2);
     }
     row = result.FetchRow();
     System.err.println(row);
     back = Integer.parseInt(row[0]);
   }  catch (MsqlException e) {
      }
      catch (NullPointerException e2) {
          return(-2);
      }
    pswd = "delete from pswd where username='"+ username +"'";
    billing = "delete from billing where username='"+ username +"'";
    System.err.println(pswd);
    System.err.println("");
    System.err.println(billing);
    System.err.println("");
    try {
      msql.Query(pswd);
      msql.Query(billing);
    } catch (MsqlException e3) {
        disconnect_db(msql);
        return(-1);
      }

    disconnect_db(msql);
    return(back);
  }

  // Update policy file
  public int update_policy(String policy[]) {
    int start;
    int end;
    String parsed;
    String delete;
    String insert;
    int counter;
    String class_id;
    int i;
    connect_db(msql);
    for (i=0; i<=policy.length-1; i++) {
      start=0;
      end=0;
      // Setting up with ('
      parsed="(";
      // Finding the class
      end = policy[i].indexOf(" ");
      // Having (0,
      class_id=policy[i].substring(start,end);
      parsed = parsed + policy[i].substring(start,end) + ",'";
      // Ready to get start time
      start = policy[i].indexOf(" ")+1;
      end = policy[i].indexOf(" ",start);
      // have (0,'21:00:00','
      parsed = parsed + policy[i].substring(start,end) + "','";
      // Ready to get end time
      start = policy[i].indexOf(" ",end)+1;
      end = policy[i].indexOf(" ",start);
      // have (0,'21:00:00','21:00:00:00',
      parsed = parsed + policy[i].substring(start,end) + "',";
      // Ready to get price
      start = policy[i].indexOf(" ",end)+1;
      end = policy[i].indexOf(" ",start);
      // have (0,'21:00:00','21:00:00:00',5,
      parsed = parsed + policy[i].substring(start,end) + ",";
      // Ready to get signalling
      start = policy[i].indexOf(" ",end)+1;
      end = policy[i].indexOf(" ",start);
      // have (0,'21:00:00','21:00:00:00',5,0)
      parsed = parsed + policy[i].substring(start) + ")";
      System.err.println(parsed);
      if (i==0) {
        delete = "delete from policy where class=" + class_id;
        System.err.println(delete);
        try {
        System.err.println(delete);
             msql.Query(delete);
        System.err.println(delete);
        } catch (MsqlException e) {
          }
      }
      insert = "insert into policy values " + parsed;
      System.err.println(insert);
      try {
            msql.Query(insert);
          } catch (MsqlException e) {}
    }
    disconnect_db(msql);
    return(0);
  }

  // Set information about the user
  // Output is a String
  // [0] fullname
  // [1] email
  // [2] credit card
  // [3] password
  public int set_info(String username, String[] info) {
    String row[];
    String command1;
    String command2;
    connect_db(msql);
    command1= "update billing set ";
    if (!info[0].equals("")) command1=command1+"name='"+info[0]+"' ";
    if (!info[1].equals("")) command1=command1+",email='"+info[1]+"' ";
    if (!info[2].equals("")) command1=command1+",card='"+info[2]+"' ";
    command1=command1+" where username='"+username+"'";
    if (!(info[0].equals("")) || !(info[1].equals("")) || 
       !(info[2].equals(""))) {
      try {
        msql.Query(command1);
      } catch (MsqlException e) {
         return(-1);
        }
    }
    if (!info[3].equals("")) {
      command2= "update pswd set password='"+ info[3] + 
                "' where username='" + username + "'";
      try {
        msql.Query(command2);
      } catch (MsqlException e) { 
         return(-1);
        }
    }
    disconnect_db(msql);
    return(0);
  }











// Testing methods

  public void show_db () {
  
   msql = new Msql();
   connect_db(msql);
   // Print the databases inside the db
   try {
   String database[] = msql.ListDBs();
   System.err.println((String) database[0]);
   } catch (MsqlException e) { 
     }
   //
   disconnect_db(msql);

  }


  public void fetch_table_db(String tablename) {

   //  msql = new Msql();
   //  connect_db(msql);
   try {
     MsqlResult result = msql.Query(
          "select *" +
          "from " + tablename
     );
     String row[];
     int counter=0;
     while((row = result.FetchRow()) != null) {
      System.err.println(row[0] + " " + row[1] + " " + row[2] + counter);
      counter++;
     }
   } catch(MsqlException e) {}



  }
}


class Parser {
 String username;
 String class_id;
 String bw;
 String dest;
 String hops;
 String sdate;
 String stime;
 String edate;
 String etime;
 int pr;

 public static void main() {
 }
 
 Parser() {
 }

 Parser(String username, String call) {
  int start=0;
  int end=0;
  long duration;
  bw="";
  hops="";
  // Setting the username
  this.username=username;
  // Taking the class
  end=call.indexOf(" ");
  class_id = call.substring(start,end);
  // Taking the destination
  start = call.indexOf(" ",end)+1;
  end = call.indexOf(" ",start);
  dest = call.substring(start,end);
  // Taking the starting date
  start = call.indexOf(" ",end)+1;
  end = call.indexOf(" ",start);
  sdate = call.substring(start,end);
  // Taking the starting time
  start = call.indexOf(" ",end)+1;
  end = call.indexOf(" ",start);
  stime = call.substring(start,end);
 
  // Instead of edate etime we get the duration in seconds
  // Taking the ending date
  //start = call.indexOf(" ",end)+1;
  //end = call.indexOf(" ",start);
  //edate = call.substring(start,end);
  // Taking the ending time
  //start = call.indexOf(" ",end)+1;
  //end = call.indexOf(" ",start);
  //etime = call.substring(start,end);
 
  start = call.indexOf(" ",end)+1;
  end = call.indexOf(" ",start);
  duration = ((new Long(call.substring(start,end))).longValue());
//System.err.println("Duration "+new Long(call.substring(start,end)).longValue());
  //duration = LongValue(new Long(call.substring(start,end)));
  ParsePosition p = new ParsePosition(0);
  SimpleDateFormat pdt = new SimpleDateFormat ("dd-MMM-yyyy HH:mm:ss");
  Date d  = pdt.parse(sdate + " " + stime, p);
//System.err.println("Now "); 
//System.err.println("Now " + pdt.format(d));
//System.err.println("Now " + d.getTime() + "+" + duration*1000);
  SimpleDateFormat df = new SimpleDateFormat ("dd-MMM-yyyy");
  SimpleDateFormat tf = new SimpleDateFormat ("HH:mm:ss");
  edate=df.format(new Date(d.getTime()+duration*1000));
  etime=tf.format(new Date(d.getTime()+duration*1000));
  // Taking the price
  start = call.indexOf(" ",end)+1;
  end = call.indexOf(" ",start);
  pr = Integer.parseInt(call.substring(start));
 }


}








// class for billing rows
class Billing_Row {

 String sdate;
 String stime;
 String edate;
 int price;
 public static void main() {
 }

}
