/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;


public class Login extends Frame
{
    String username;
    
	public Login()
	{
		setLayout(null);
		setVisible(false);
		setSize(407,331);
		setFont(new Font("Dialog", Font.BOLD|Font.ITALIC, 12));
		setBackground(new Color(-12550016));
		textField1 = new java.awt.TextField();
		textField1.setBounds(180,132,96,31);
		textField1.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		add(textField1);
		label1 = new java.awt.Label("   Username");
		label1.setBounds(84,132,101,29);
		label1.setFont(new Font("SansSerif", Font.BOLD, 14));
		label1.setBackground(new Color(-12550016));
		add(label1);
		textField2 = new java.awt.TextField();
		textField2.setEchoChar('*');
		textField2.setBounds(180,180,96,31);
		textField2.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		add(textField2);
		label2 = new java.awt.Label("   Password");
		label2.setBounds(84,180,101,29);
		label2.setFont(new Font("SansSerif", Font.BOLD, 14));
		label2.setBackground(new Color(-12550016));
		add(label2);
		button1 = new java.awt.Button();
		button1.setLabel("Login");
		button1.setBounds(156,240,58,31);
		button1.setFont(new Font("Dialog", Font.BOLD, 16));
		button1.setBackground(new Color(12632256));
		add(button1);
		button2 = new java.awt.Button();
		button2.setLabel("Reset");
		button2.setBounds(216,240,60,31);
		button2.setFont(new Font("Dialog", Font.BOLD, 16));
		button2.setBackground(new Color(12632256));
		add(button2);
		label3 = new java.awt.Label("Try Logging into the System");
		label3.setBounds(72,288,276,24);
		label3.setFont(new Font("DialogInput", Font.PLAIN, 17));
		label3.setBackground(new Color(12632256));
		add(label3);
		label4 = new java.awt.Label("Simulation Manager");
		label4.setBounds(60,24,324,48);
		label4.setFont(new Font("Dialog", Font.PLAIN, 30));
		label4.setForeground(new Color(16762880));
		add(label4);
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		button2.addMouseListener(aSymMouse);
		button1.addMouseListener(aSymMouse);
	}
	

	public Login(String title)
	{
		this();
		setTitle(title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
//		(new Login()).setVisible(true);
	}
	
	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	boolean fComponentsAdjusted = false;

	java.awt.TextField textField1;
	java.awt.Label label1;
	java.awt.TextField textField2;
	java.awt.Label label2;
	java.awt.Button button1;
	java.awt.Button button2;
	java.awt.Label label3;
	java.awt.Label label4;


	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == Login.this)
				Frame1_WindowClosing(event);
		}
	}
	
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == button2)
				button2_MouseClicked(event);
			else if (object == button1)
				button1_MouseClicked(event);
		}
	}

	void button2_MouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		textField1.setText("");
		//}}
			 
		textField2.setText("");
		//}}
	}

	void button1_MouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
        label3.setText("  Connecting to database ");
		int result;
		DB db = new DB();
		db.show_db();
		result = db.authenticate(textField1.getText(),
		                         textField2.getText());
		System.err.println(result);
		if (result == -1) {
		    label3.setText(" Invalid Login. Try again");
		}
		else {
		    System.err.println("Ready to make it active");
            this.setVisible(false);
     		Select select = new Select();
     		System.err.println("Ready to make it active");
     		select.setVisible(true);
     		select.initialize();
     		select.username=textField1.getText();
        }
		
	}
}
