import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import java.io.*;
import java.text.*;
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.applet.Applet;

public class SimpleThread extends Thread {

    private Monitor monitor;
    private String id;
    String pwd="/q/toltec/home/toltec/psebos/ais/gui/classes";


    public SimpleThread(Monitor monitor, String id)
    {
        this.monitor=monitor;
        this.id=id;

    }


    public void run() {
      System.err.println("Initializing "+id);
        if ((id.equals("1"))) {
           manage1(monitor.values[0][2],monitor.values[0][1],
				monitor.values[0][0],monitor.time[0]);
        }
        if ((id.equals("2"))) manage2(monitor.values[1][2],
                    monitor.values[1][1],monitor.values[1][0],monitor.time[1]);
        if ((id.equals("3"))) manage3(monitor.values[2][2],
                    monitor.values[2][1],monitor.values[2][0],monitor.time[2]);
        if ((id.equals("4"))) manage4(monitor.values[3][2],
                    monitor.values[3][1],monitor.values[3][0],monitor.time[3]);
        //for (int i = 0; i < 10; i++) {
        //System.out.println(i + " " + getName());
        //try {
        //    sleep((int)(Math.random() * 1000));
        //} catch (InterruptedException e) {}
        //}

    System.out.println("DONE! " + id);
    }


    public void manage1(String name, String command, String hostname, int time)
    {
        String message;
        int counter=0;
        int code=1;
        SimpleDateFormat pt = new SimpleDateFormat ("HH:mm:ss");
        SimpleDateFormat pd = new SimpleDateFormat ("dd-MMM-yy");
        Date now = new Date();
        String sdate = pd.format(now);
        String stime = pt.format(now);
        FileWriter ff1;
        String f1 = "/q/toltec/home/toltec/psebos/ais/gui/classes/"+name;
       try {
        System.err.println(name+" "+command+" "+hostname);
        // Green monitor.button1.setBackground(new Color(65344));
        // Red 16711680
        // Orange 16762880
    	try {
    		  Thread.sleep(500);
    		} catch (Exception e) {}
        //monitor.textArea1.setForeground(new Color(16711680));
    	monitor.textArea1.append("\n");
        monitor.textArea1.append("Sending command to "+hostname);
    	monitor.textArea1.append("\n");
    	try {
    		  Thread.sleep(2000);
    		} catch (Exception e) {}
        ff1 = new FileWriter(f1);
        ff1.write("Received Command\n");
        ff1.write("Running "+command+"\n");
        ff1.close();
        if (SendInit(hostname,command) == 1)monitor.button1.setBackground(new Color(65344));
        while((counter<=time) && (code>0))
        {
            // textArea1.setForeground(new Color(255));
            //
            //
            monitor.textArea1.append("Getting the state of "+hostname+"...");
            try {
      		  Thread.sleep(200);
     	    } catch (Exception e) {}
            ff1 = new FileWriter(f1,true);
            ff1.write("Received GetState\n");
            ff1.close();
            try {
      		  Thread.sleep(500);
     	    } catch (Exception e) {}
        	monitor.textArea1.append("\n");
            code=GetState(hostname);
            if (code<0)
            {
                monitor.textArea1.append("Simulation on "+hostname+" stopped with an error code");
                monitor.textArea1.append("\n");
                monitor.button1.setBackground(new Color(16711680));
            }
            else
            {

                monitor.textArea1.append("Simulation is running...");
                monitor.textArea1.append("\n");
                monitor.textArea1.append("Looking for new messages...");
                monitor.textArea1.append("\n");
            	try {
        		  Thread.sleep(200);
    	    	} catch (Exception e) {}
                ff1 = new FileWriter(f1,true);
                ff1.write("Received GetMessages\n");
                ff1.close();
            	try {
        		  Thread.sleep(500);
    	    	} catch (Exception e) {}
                GetMessage(hostname);
                monitor.textArea1.append("No new messages...");
                monitor.textArea1.append("\n");
            	try {
        		  Thread.sleep(10000);
    	    	} catch (Exception e) {}
            	counter+=10;
            	System.err.println("Time "+time+" Counter "+counter);
            }

        }
        if (counter>=time)
        {
            // end of simulation

            monitor.textArea1.append("Simulation on "+hostname+
                          "\n has ended after..."+time*321+" seconds");
            monitor.textArea1.append("\n");
           	try {
       		  Thread.sleep(10000);
   	    	} catch (Exception e) {}
            monitor.textArea1.append("Storing output in to the DB...");
            monitor.textArea1.append("\n");
            now = new Date();
            String edate = pd.format(now);
            String etime = pt.format(now);
            GetOutput(name,sdate,stime,edate,etime,command);
           	try {
       		  Thread.sleep(200);
   	    	} catch (Exception e) {}
            ff1 = new FileWriter(f1,true);
            ff1.write("Received Store username="+monitor.username+
                      "line "+name+" "+sdate+" "+stime+" "+edate
                      +" "+etime+" "+command+"\n");
            ff1.write("Store object to DB\n");
            ff1.close();
           	try {
       		  Thread.sleep(5000);
   	    	} catch (Exception e) {}
            ff1 = new FileWriter(f1,true);
            ff1.write("Stored\n\n");
            ff1.close();
           	try {
       		  Thread.sleep(500);
   	    	} catch (Exception e) {}
            monitor.button1.setBackground(new Color(16762880));
            monitor.textArea1.append("DONE...");

        }
       } catch (IOException e) {}

    }

    public void manage2(String name, String command, String hostname, int time)
    {
        String message;
        int counter=0;
        int code=1;
        SimpleDateFormat pt = new SimpleDateFormat ("HH:mm:ss");
        SimpleDateFormat pd = new SimpleDateFormat ("dd-MMM-yy");
        Date now = new Date();
        String sdate = pd.format(now);
        String stime = pt.format(now);
        FileWriter ff2;
        String f2 = "/q/toltec/home/toltec/psebos/ais/gui/classes/"+name;
       try {
        System.err.println(name+" "+command+" "+hostname);
        // Green monitor.button1.setBackground(new Color(65344));
        // Red 16711680
        // Orange 16762880
    	try {
    		  Thread.sleep(500);
    		} catch (Exception e) {}
        //monitor.textArea2.setForeground(new Color(16711680));
    	monitor.textArea2.append("\n");
        monitor.textArea2.append("Sending command to "+hostname);
    	monitor.textArea2.append("\n");
    	try {
    		  Thread.sleep(2000);
    		} catch (Exception e) {}
        ff2 = new FileWriter(f2);
        ff2.write("Received Command\n");
        ff2.write("Running "+command+"\n");
        ff2.close();
        if (SendInit(hostname,command) == 1)monitor.button1.setBackground(new Color(65344));
        while((counter<=time) && (code>0))
        {
            // textArea2.setForeground(new Color(255));
            //
            //
            monitor.textArea2.append("Getting the state of "+hostname+"...");
            try {
      		  Thread.sleep(200);
     	    } catch (Exception e) {}
            ff2 = new FileWriter(f2,true);
            ff2.write("Received GetState\n");
            ff2.close();
            try {
      		  Thread.sleep(500);
     	    } catch (Exception e) {}
        	monitor.textArea2.append("\n");
            code=GetState(hostname);
            if (code<0)
            {
                monitor.textArea2.append("Simulation on "+hostname+" stopped with an error code");
                monitor.textArea2.append("\n");
                monitor.button1.setBackground(new Color(16711680));
            }
            else
            {

                monitor.textArea2.append("Simulation is running...");
                monitor.textArea2.append("\n");
                monitor.textArea2.append("Looking for new messages...");
                monitor.textArea2.append("\n");
            	try {
        		  Thread.sleep(200);
    	    	} catch (Exception e) {}
                ff2 = new FileWriter(f2,true);
                ff2.write("Received GetMessages\n");
                ff2.close();
            	try {
        		  Thread.sleep(500);
    	    	} catch (Exception e) {}
                GetMessage(hostname);
                monitor.textArea2.append("No new messages...");
                monitor.textArea2.append("\n");
            	try {
        		  Thread.sleep(10000);
    	    	} catch (Exception e) {}
            	counter+=10;
            	System.err.println("Time "+time+" Counter "+counter);
            }

        }
        if (counter>=time)
        {
            // end of simulation

            monitor.textArea2.append("Simulation on "+hostname+
                          "\n has ended after..."+time*321+" seconds");
            monitor.textArea2.append("\n");
           	try {
       		  Thread.sleep(10000);
   	    	} catch (Exception e) {}
            monitor.textArea2.append("Storing output in to the DB...");
            monitor.textArea2.append("\n");
            now = new Date();
            String edate = pd.format(now);
            String etime = pt.format(now);
            GetOutput(name,sdate,stime,edate,etime,command);
           	try {
       		  Thread.sleep(200);
   	    	} catch (Exception e) {}
            ff2 = new FileWriter(f2,true);
            ff2.write("Received Store username="+monitor.username+
                      "line "+name+" "+sdate+" "+stime+" "+edate
                      +" "+etime+" "+command+"\n");
            ff2.write("Store object to DB\n");
            ff2.close();
           	try {
       		  Thread.sleep(5000);
   	    	} catch (Exception e) {}
            ff2 = new FileWriter(f2,true);
            ff2.write("Stored\n\n");
            ff2.close();
           	try {
       		  Thread.sleep(500);
   	    	} catch (Exception e) {}
            monitor.button1.setBackground(new Color(16762880));
            monitor.textArea2.append("DONE...");

        }
       } catch (IOException e) {}

    }

    public void manage3(String name, String command, String hostname, int time)
    {
        String message;
        int counter=0;
        int code=1;
        SimpleDateFormat pt = new SimpleDateFormat ("HH:mm:ss");
        SimpleDateFormat pd = new SimpleDateFormat ("dd-MMM-yy");
        Date now = new Date();
        String sdate = pd.format(now);
        String stime = pt.format(now);
        FileWriter ff3;
        String f3 = "/q/toltec/home/toltec/psebos/ais/gui/classes/"+name;
       try {
        System.err.println(name+" "+command+" "+hostname);
        // Green monitor.button3.setBackground(new Color(65344));
        // Red 16711680
        // Orange 16762880
    	try {
    		  Thread.sleep(500);
    		} catch (Exception e) {}
        //monitor.textArea3.setForeground(new Color(16711680));
    	monitor.textArea3.append("\n");
        monitor.textArea3.append("Sending command to "+hostname);
    	monitor.textArea3.append("\n");
    	try {
    		  Thread.sleep(2000);
    		} catch (Exception e) {}
        ff3 = new FileWriter(f3);
        ff3.write("Received Command\n");
        ff3.write("Running "+command+"\n");
        ff3.close();
        if (SendInit(hostname,command) == 1)monitor.button3.setBackground(new Color(65344));
        while((counter<=time) && (code>0))
        {
            // textArea3.setForeground(new Color(255));
            //
            //
            monitor.textArea3.append("Getting the state of "+hostname+"...");
            try {
      		  Thread.sleep(200);
     	    } catch (Exception e) {}
            ff3 = new FileWriter(f3,true);
            ff3.write("Received GetState\n");
            ff3.close();
            try {
      		  Thread.sleep(500);
     	    } catch (Exception e) {}
        	monitor.textArea3.append("\n");
            code=GetState(hostname);
            if (code<0)
            {
                monitor.textArea3.append("Simulation on "+hostname+" stopped with an error code");
                monitor.textArea3.append("\n");
                monitor.button3.setBackground(new Color(16711680));
            }
            else
            {

                monitor.textArea3.append("Simulation is running...");
                monitor.textArea3.append("\n");
                monitor.textArea3.append("Looking for new messages...");
                monitor.textArea3.append("\n");
            	try {
        		  Thread.sleep(200);
    	    	} catch (Exception e) {}
                ff3 = new FileWriter(f3,true);
                ff3.write("Received GetMessages\n");
                ff3.close();
            	try {
        		  Thread.sleep(500);
    	    	} catch (Exception e) {}
                GetMessage(hostname);
                monitor.textArea3.append("No new messages...");
                monitor.textArea3.append("\n");
            	try {
        		  Thread.sleep(10000);
    	    	} catch (Exception e) {}
            	counter+=10;
            	System.err.println("Time "+time+" Counter "+counter);
            }

        }
        if (counter>=time)
        {
            // end of simulation

            monitor.textArea3.append("Simulation on "+hostname+
                          "\n has ended after..."+time*321+" seconds");
            monitor.textArea3.append("\n");
           	try {
       		  Thread.sleep(10000);
   	    	} catch (Exception e) {}
            monitor.textArea3.append("Storing output in to the DB...");
            monitor.textArea3.append("\n");
            now = new Date();
            String edate = pd.format(now);
            String etime = pt.format(now);
            GetOutput(name,sdate,stime,edate,etime,command);
           	try {
       		  Thread.sleep(200);
   	    	} catch (Exception e) {}
            ff3 = new FileWriter(f3,true);
            ff3.write("Received Store username="+monitor.username+
                      "line "+name+" "+sdate+" "+stime+" "+edate
                      +" "+etime+" "+command+"\n");
            ff3.write("Store object to DB\n");
            ff3.close();
           	try {
       		  Thread.sleep(5000);
   	    	} catch (Exception e) {}
            ff3 = new FileWriter(f3,true);
            ff3.write("Stored\n\n");
            ff3.close();
           	try {
       		  Thread.sleep(500);
   	    	} catch (Exception e) {}
            monitor.button3.setBackground(new Color(16762880));
            monitor.textArea3.append("DONE...");

        }
       } catch (IOException e) {}

    }

    public void manage4(String name, String command, String hostname, int time)
    {
        String message;
        int counter=0;
        int code=1;
        SimpleDateFormat pt = new SimpleDateFormat ("HH:mm:ss");
        SimpleDateFormat pd = new SimpleDateFormat ("dd-MMM-yy");
        Date now = new Date();
        String sdate = pd.format(now);
        String stime = pt.format(now);
        FileWriter ff4;
        String f4 = "/q/toltec/home/toltec/psebos/ais/gui/classes/"+name;
       try {
        System.err.println(name+" "+command+" "+hostname);
        // Green monitor.button4.setBackground(new Color(65344));
        // Red 16711680
        // Orange 16762880
    	try {
    		  Thread.sleep(500);
    		} catch (Exception e) {}
        //monitor.textArea4.setForeground(new Color(16711680));
    	monitor.textArea4.append("\n");
        monitor.textArea4.append("Sending command to "+hostname);
    	monitor.textArea4.append("\n");
    	try {
    		  Thread.sleep(2000);
    		} catch (Exception e) {}
        ff4 = new FileWriter(f4);
        ff4.write("Received Command\n");
        ff4.write("Running "+command+"\n");
        ff4.close();
        if (SendInit(hostname,command) == 1)monitor.button4.setBackground(new Color(65344));
        while((counter<=time) && (code>0))
        {
            // textArea4.setForeground(new Color(255));
            //
            //
            monitor.textArea4.append("Getting the state of "+hostname+"...");
            try {
      		  Thread.sleep(200);
     	    } catch (Exception e) {}
            ff4 = new FileWriter(f4,true);
            ff4.write("Received GetState\n");
            ff4.close();
            try {
      		  Thread.sleep(500);
     	    } catch (Exception e) {}
        	monitor.textArea4.append("\n");
            code=GetState(hostname);
            if (code<0)
            {
                monitor.textArea4.append("Simulation on "+hostname+" stopped with an error code");
                monitor.textArea4.append("\n");
                monitor.button4.setBackground(new Color(16711680));
            }
            else
            {

                monitor.textArea4.append("Simulation is running...");
                monitor.textArea4.append("\n");
                monitor.textArea4.append("Looking for new messages...");
                monitor.textArea4.append("\n");
            	try {
        		  Thread.sleep(200);
    	    	} catch (Exception e) {}
                ff4 = new FileWriter(f4,true);
                ff4.write("Received GetMessages\n");
                ff4.close();
            	try {
        		  Thread.sleep(500);
    	    	} catch (Exception e) {}
                GetMessage(hostname);
                monitor.textArea4.append("No new messages...");
                monitor.textArea4.append("\n");
            	try {
        		  Thread.sleep(10000);
    	    	} catch (Exception e) {}
            	counter+=10;
            	System.err.println("Time "+time+" Counter "+counter);
            }

        }
        if (counter>=time)
        {
            // end of simulation

            monitor.textArea4.append("Simulation on "+hostname+
                          "\n has ended after..."+time*321+" seconds");
            monitor.textArea4.append("\n");
           	try {
       		  Thread.sleep(10000);
   	    	} catch (Exception e) {}
            monitor.textArea4.append("Storing output in to the DB...");
            monitor.textArea4.append("\n");
            now = new Date();
            String edate = pd.format(now);
            String etime = pt.format(now);
            GetOutput(name,sdate,stime,edate,etime,command);
           	try {
       		  Thread.sleep(200);
   	    	} catch (Exception e) {}
            ff4 = new FileWriter(f4,true);
            ff4.write("Received Store username="+monitor.username+
                      "line "+name+" "+sdate+" "+stime+" "+edate
                      +" "+etime+" "+command+"\n");
            ff4.write("Store object to DB\n");
            ff4.close();
           	try {
       		  Thread.sleep(5000);
   	    	} catch (Exception e) {}
            ff4 = new FileWriter(f4,true);
            ff4.write("Stored\n\n");
            ff4.close();
           	try {
       		  Thread.sleep(500);
   	    	} catch (Exception e) {}
            monitor.button4.setBackground(new Color(16762880));
            monitor.textArea4.append("DONE...");

        }
       } catch (IOException e) {}

    }


    public int SendInit(String hostname, String command)
    {
        return(1);
    }

    public int GetState(String hostname)
    {
        return(1);
    }

    public String GetMessage(String hostname)
    {
        return("Test");
    }


    public int GetOutput(String name, String sdate,String stime,
                         String edate, String etime, String command)
    {
        DB db = new DB();
        db.Enter(name,sdate,stime,edate,etime,command);
        return(1);
    }


}
